# Oslobike, a rust wrapper for the Oslo City Bike open API

## Building

To build the project, be sure to have an up to date rust develppment environment installed. The easiest ways is to install the toolchain via [rustup]:

    rustup install stable

You need at least Rust v1.32 to build and run this program.

You also need an API key, which you can get here: <https://developer.oslobysykkel.no/api>

To run the program, run:

    OSLOBIKE_APIKEY=<your api key> cargo run

You can also save the API key in a file `.env` in the root of the project, and the program will pick it up automatically.

    echo OSLOBIKE_APIKEY=<your api key> > .env
    cargo run

To build the docs:

    cargo doc --lib

To test documentation:

    cargo test

To build a release of the project:

    cargo build --release

The binary is found in `./target/release/oslobike`.

## License

    Copyright (C) 2019  Harald Eilertsen

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <https://www.gnu.org/licenses/>.

[rustup]: https://rustup.rs/
